# Go API client for swagger

This is the API behind the APIs.io search engine.

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: V1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.go.GoClientCodegen

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://ibmwu99rx3.execute-api.us-east-1.amazonaws.com/staging*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SearchApi* | [**AddAPI**](docs/SearchApi.md#addapi) | **Post** /search/apis | Submit API
*SearchApi* | [**SearchAPIs**](docs/SearchApi.md#searchapis) | **Get** /search/apis | Search APIs
*SearchApi* | [**SearchMaintainers**](docs/SearchApi.md#searchmaintainers) | **Get** /search/maintainers | Search Maintainers

## Documentation For Models

 - [AnyOfSearchDataItems](docs/AnyOfSearchDataItems.md)
 - [Api](docs/Api.md)
 - [ApisJson](docs/ApisJson.md)
 - [Contact](docs/Contact.md)
 - [DiagnosticSeverity](docs/DiagnosticSeverity.md)
 - [HumanReadableSeverity](docs/HumanReadableSeverity.md)
 - [Include](docs/Include.md)
 - [Latest](docs/Latest.md)
 - [LatestProperties](docs/LatestProperties.md)
 - [LatestPropertiesRules](docs/LatestPropertiesRules.md)
 - [LatestRules](docs/LatestRules.md)
 - [MetaInformation](docs/MetaInformation.md)
 - [Property](docs/Property.md)
 - [PublishApis](docs/PublishApis.md)
 - [PublishMaintainers](docs/PublishMaintainers.md)
 - [PublishProperties](docs/PublishProperties.md)
 - [PublishTags](docs/PublishTags.md)
 - [Rule](docs/Rule.md)
 - [Search](docs/Search.md)
 - [SearchLinks](docs/SearchLinks.md)
 - [SearchMeta](docs/SearchMeta.md)
 - [Severity](docs/Severity.md)
 - [UpdateMaintainers](docs/UpdateMaintainers.md)
 - [UpdateProperties](docs/UpdateProperties.md)
 - [UpdateTags](docs/UpdateTags.md)

## Documentation For Authorization

## api_key
- **Type**: API key 

Example
```golang
auth := context.WithValue(context.Background(), sw.ContextAPIKey, sw.APIKey{
	Key: "APIKEY",
	Prefix: "Bearer", // Omit if not necessary.
})
r, err := client.Service.Operation(auth, args)
```

## Author

info@apievangelist.com
